﻿SystemOrganization addCategory: #'Nagare-Core'!

!Exception methodsFor: '*Nagare-Core' stamp: 'mu 5/3/2012 01:15'!
ngLog
	self ng logException: self.
	^self! !

!BlockClosure methodsFor: '*Nagare-Core' stamp: 'mu 5/3/2012 14:50'!
ngLogTime
	^ self ngLogTimeAt: thisContext sender printString! !

!BlockClosure methodsFor: '*Nagare-Core' stamp: 'mu 5/3/2012 14:50'!
ngLogTimeAt: tracePoint
	^ self ng logTimeToRun: self at: tracePoint.
	! !

!BlockClosure methodsFor: '*Nagare-Core' stamp: 'mu 5/3/2012 16:22'!
ngLogTimeAt: tracePoint description: description
	^ self ng logTimeToRun: self at: tracePoint description: description.
	! !

Object subclass: #NgLog
	instanceVariableNames: 'policy settings tagPrefix accessTag adminTag debugTag fatalTag infoTag perfTag errorTag warnTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nagare-Core'!

NgLog class
	instanceVariableNames: 'default'!

NgLog class
	instanceVariableNames: 'default'!

!NgLog class methodsFor: 'preset tag types' stamp: 'mu 5/2/2012 15:26'!
accessTag
	^'.access'! !

!NgLog class methodsFor: 'preset tag types' stamp: 'mu 5/2/2012 15:27'!
adminTag
	^'.admin'! !

!NgLog class methodsFor: 'preset tag types' stamp: 'mu 5/2/2012 15:26'!
debugTag
	^'.debug'! !

!NgLog class methodsFor: 'instance creation' stamp: 'mu 5/3/2012 22:04'!
default
	"NgLog default"
	default ifNil: [default := NgLogFactory defaultLogger].
	^default! !

!NgLog class methodsFor: 'preset tag types' stamp: 'mu 5/2/2012 17:13'!
errorTag
	^'.error'! !

!NgLog class methodsFor: 'preset tag types' stamp: 'mu 5/2/2012 15:26'!
fatalTag
	^'.fatal'! !

!NgLog class methodsFor: 'preset tag types' stamp: 'mu 5/2/2012 15:26'!
infoTag
	^'.info'! !

!NgLog class methodsFor: 'class initialization' stamp: 'mu 5/3/2012 14:47'!
initialize
	"NgLog initialize"
	default := nil! !

!NgLog class methodsFor: 'preset tag types' stamp: 'mu 5/3/2012 14:46'!
perfTag
	^'.perf'! !

!NgLog class methodsFor: 'class initialization' stamp: 'mu 5/4/2012 12:20'!
release
	"NgLog release"
	NgPortableUtil release! !

!NgLog class methodsFor: 'instance creation' stamp: 'mu 5/3/2012 21:30'!
tagPrefix: tagPrefix
	^self basicNew tagPrefix: tagPrefix; initialize; yourself! !

!NgLog class methodsFor: 'preset tag types' stamp: 'mu 5/2/2012 15:26'!
warnTag
	^'.warn'! !

!NgLog methodsFor: 'comparing' stamp: 'mu 5/3/2012 21:34'!
= other
	self class = other class ifFalse: [^false].
	^ self tagPrefix = other tagPrefix! !

!NgLog methodsFor: 'logging' stamp: 'mu 5/3/2012 16:50'!
access: record
	(self policy shouldLogAccess) ifFalse: [^self].
	^self portableUtil sendLog: record tagged: self accessTag on: self! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:38'!
accessTag
	"Answer the value of accessTag"

	^ accessTag! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:38'!
accessTag: anObject
	"Set the value of accessTag"

	accessTag := anObject! !

!NgLog methodsFor: 'logging' stamp: 'mu 5/3/2012 16:50'!
admin: record
	(self policy shouldLogAdmin) ifFalse: [^self].
	^self portableUtil sendLog: record tagged: self adminTag on: self! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:38'!
adminTag
	"Answer the value of adminTag"

	^ adminTag! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:38'!
adminTag: anObject
	"Set the value of adminTag"

	adminTag := anObject! !

!NgLog methodsFor: 'encoding' stamp: 'mu 5/3/2012 17:29'!
asRecord: anObject
	self settings useStomp ifTrue: [^ anObject].
	^ self portableUtil asRecord: anObject! !

!NgLog methodsFor: 'encoding' stamp: 'mu 5/3/2012 17:26'!
bytesToSendFrom: record tagged: tag
	| logMessage |
	logMessage := self newLogMessage: tag record: (self asRecord: record).
	^self encodeMessage: logMessage! !

!NgLog methodsFor: 'logging' stamp: 'mu 5/3/2012 16:50'!
debug: exceptionOrRecord
	| record |
	(self policy shouldLogDebug) ifFalse: [^self].
	record := self portableUtil errorRecordFrom: exceptionOrRecord.
	^self portableUtil sendLog: record tagged: self debugTag on: self! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:38'!
debugTag
	"Answer the value of debugTag"

	^ debugTag! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:38'!
debugTag: anObject
	"Set the value of debugTag"

	debugTag := anObject! !

!NgLog methodsFor: 'encoding' stamp: 'mu 5/3/2012 17:22'!
encodeByMessagePack: logMessage
	"use plainer MP for encoding"
	| enc |
	enc := MpEncoder onBytes: (ByteArray new: 30).
	enc settings stringAsBytes: true.
	^enc encode: logMessage.! !

!NgLog methodsFor: 'encoding' stamp: 'mu 5/3/2012 17:22'!
encodeByStomp: logMessage
	"use richer StOMP(Smalltalk Object MP) for encoding"
	| enc |
	enc := StompWriter onBytes: (ByteArray new: 50).
	^enc encode: logMessage.! !

!NgLog methodsFor: 'encoding' stamp: 'mu 5/3/2012 17:23'!
encodeMessage: logMessage
	"logMessage => tag, timestamp, record"
	self settings useStomp ifTrue: [^ self encodeByStomp: logMessage].
	^self encodeByMessagePack: logMessage! !

!NgLog methodsFor: 'logging' stamp: 'mu 5/3/2012 16:50'!
error: exceptionOrRecord
	| record |
	(self policy shouldLogError) ifFalse: [^self].
	record := self portableUtil errorRecordFrom: exceptionOrRecord.
	^self portableUtil sendLog: record tagged: self errorTag on: self! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:13'!
errorTag
	"Answer the value of errorTag"

	^ errorTag! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:13'!
errorTag: anObject
	"Set the value of errorTag"

	errorTag := anObject! !

!NgLog methodsFor: 'logging' stamp: 'mu 5/3/2012 16:50'!
fatal: exceptionOrRecord
	| record |
	(self policy shouldLogFatal) ifFalse: [^self].
	record := self portableUtil errorRecordFrom: exceptionOrRecord.
	^self portableUtil sendLog: record tagged: self fatalTag on: self! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:38'!
fatalTag
	"Answer the value of fatalTag"

	^ fatalTag! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:38'!
fatalTag: anObject
	"Set the value of fatalTag"

	fatalTag := anObject! !

!NgLog methodsFor: 'comparing' stamp: 'mu 5/3/2012 21:34'!
hash
	^ self class name hash bitXor: self tagPrefix hash! !

!NgLog methodsFor: 'logging' stamp: 'mu 5/3/2012 16:50'!
info: record
	(self policy shouldLogInfo) ifFalse: [^self].
	^self portableUtil sendLog: record tagged: self infoTag on: self! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:38'!
infoTag
	"Answer the value of infoTag"

	^ infoTag! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:38'!
infoTag: anObject
	"Set the value of infoTag"

	infoTag := anObject! !

!NgLog methodsFor: 'initialize-release' stamp: 'mu 5/3/2012 14:45'!
initTags
	#(accessTag adminTag debugTag fatalTag infoTag perfTag errorTag warnTag)
		do: [:each | | tag |
		tag := self tagPrefix, (self class perform: each). 
		self perform: (each, ':') asSymbol with: tag
	]! !

!NgLog methodsFor: 'initialize-release' stamp: 'mu 5/3/2012 16:02'!
initialize
	policy := settings := nil.
	self initTags! !

!NgLog methodsFor: 'logging-convenient' stamp: 'mu 5/3/2012 00:02'!
logException: anException
	self policy logException: anException! !

!NgLog methodsFor: 'logging-convenient' stamp: 'mu 5/3/2012 14:50'!
logTimeToRun: aBlock at: tracePoint
	^ self logTimeToRun: aBlock at: tracePoint description: nil! !

!NgLog methodsFor: 'logging-convenient' stamp: 'mu 5/3/2012 14:52'!
logTimeToRun: aBlock at: tracePoint description: description
	| msecs |
	msecs := [Time millisecondsToRun: aBlock] on: Error do: [:ex | ex ngLog. ^-1].
	self timeConsumed: msecs at: tracePoint doing: description.
	^ msecs! !

!NgLog methodsFor: 'encoding' stamp: 'mu 5/3/2012 17:25'!
newLogMessage: tag record: aRecord
	| array |
	array := Array new: 3.
	array at: 1 put: tag asByteArray.
	array at: 2 put: self portableUtil unixTimeSeconds.
	array at: 3 put: aRecord.
	^array! !

!NgLog methodsFor: 'logging' stamp: 'mu 5/3/2012 16:51'!
perf: record
	(self policy shouldLogProfile) ifFalse: [^self].
	^self portableUtil sendLog: record tagged: self perfTag on: self! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/3/2012 14:48'!
perfTag
	"Answer the value of perfTag"

	^ perfTag! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/3/2012 14:48'!
perfTag: anObject
	"Set the value of perfTag"

	perfTag := anObject! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:49'!
policy
	policy ifNil: [policy := NgLogPolicy on: self].
	^ policy! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:43'!
policy: anObject
	"Set the value of policy"

	policy := anObject! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:46'!
portableUtil
	^NgPortableUtil default! !

!NgLog methodsFor: 'printing' stamp: 'mu 5/2/2012 15:42'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' ('.
	aStream nextPutAll: self tagPrefix.
	aStream nextPutAll: ')'.! !

!NgLog methodsFor: 'initialize-release' stamp: 'mu 5/3/2012 21:38'!
release
	NgLogFactory removeKey: self tagPrefix ifAbsent: [^self].
	self initialize! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/3/2012 16:02'!
settings
	^settings ifNil: [settings := NgSettings default]! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/3/2012 16:03'!
settings: anObject
	"Set the value of policy"

	settings := anObject! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:30'!
tagPrefix
	tagPrefix ifNil: [tagPrefix := self settings defaultTagPrefix].
	^ tagPrefix! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:29'!
tagPrefix: anObject
	"Set the value of tagPrefix"

	tagPrefix := anObject! !

!NgLog methodsFor: 'logging-convenient' stamp: 'mu 5/3/2012 14:53'!
timeConsumed: msecs at: tracePoint doing: description
	| map |
	map := Dictionary new.
	map at: #msecs put: msecs.
	map at: #tracePoint put: tracePoint.
	description ifNotNil: [map at: #description put: description].
	self perf: map! !

!NgLog methodsFor: 'logging' stamp: 'mu 5/3/2012 16:51'!
warn: exceptionOrRecord
	| record |
	(self policy shouldLogWarn) ifFalse: [^self].
	record := self portableUtil errorRecordFrom: exceptionOrRecord.
	^self portableUtil sendLog: record tagged: self warnTag on: self! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:38'!
warnTag
	"Answer the value of warnTag"

	^ warnTag! !

!NgLog methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:38'!
warnTag: anObject
	"Set the value of warnTag"

	warnTag := anObject! !

Object subclass: #NgLogFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nagare-Core'!

NgLogFactory class
	instanceVariableNames: 'loggers'!

NgLogFactory class
	instanceVariableNames: 'loggers'!

!NgLogFactory class methodsFor: 'instance creation' stamp: 'mu 5/2/2012 23:52'!
@ tagPrefix 
	^self logger: tagPrefix
	! !

!NgLogFactory class methodsFor: 'instance creation' stamp: 'mu 5/2/2012 23:42'!
at: tagPrefix ifAbsentPut: aBlock
	^self at: tagPrefix ifAbsentPut: aBlock initialized: nil! !

!NgLogFactory class methodsFor: 'instance creation' stamp: 'mu 5/2/2012 23:42'!
at: tagPrefix ifAbsentPut: aBlock initialized: initializer
	^ self loggers at: tagPrefix ifAbsentPut: [ | newLogger |
		newLogger := aBlock value.
		initializer ifNotNil: [initializer value: newLogger].
		newLogger
	] ! !

!NgLogFactory class methodsFor: 'instance creation' stamp: 'mu 5/2/2012 23:48'!
defaultLogger 
	^self logger: NgSettings default defaultTagPrefix
	! !

!NgLogFactory class methodsFor: 'class initialization' stamp: 'mu 5/3/2012 14:47'!
initialize
	"NgLogFactory initialize"
	loggers := nil! !

!NgLogFactory class methodsFor: 'instance creation' stamp: 'mu 5/2/2012 23:45'!
logger: tagPrefix 
	^self at: tagPrefix ifAbsentPut: [NgLog tagPrefix: tagPrefix].
	! !

!NgLogFactory class methodsFor: 'accessing' stamp: 'mu 5/2/2012 23:38'!
loggers
	loggers ifNil: [loggers := Dictionary new].
	^loggers! !

!NgLogFactory class methodsFor: 'removing' stamp: 'mu 5/3/2012 21:36'!
removeKey: tagPrefix ifAbsent: aBlock
	^self loggers removeKey: tagPrefix ifAbsent: aBlock ! !

Object subclass: #NgLogPolicy
	instanceVariableNames: 'logger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nagare-Core'!

!NgLogPolicy class methodsFor: 'instance creation' stamp: 'mu 5/2/2012 17:49'!
on: logger
	^self new logger: logger; yourself! !

!NgLogPolicy methodsFor: 'testing' stamp: 'mu 5/3/2012 01:09'!
consideredAsFatal: anException
	(self settings fatalClasses includes: anException) ifTrue: [^true].
	^ false! !

!NgLogPolicy methodsFor: 'testing' stamp: 'mu 5/3/2012 01:10'!
consideredAsWarning: anException
	(self settings warningClasses includes: anException) ifTrue: [^true].
	^ anException isKindOf: Warning! !

!NgLogPolicy methodsFor: 'actions' stamp: 'mu 5/2/2012 17:50'!
logException: anException
	(self consideredAsFatal: anException) ifTrue: [^self logger fatal: anException].
	(self consideredAsWarning: anException) ifTrue: [^self logger warn: anException].
	self logger error: anException! !

!NgLogPolicy methodsFor: 'accessing' stamp: 'mu 5/3/2012 01:09'!
logLevel
	^self settings logLevel! !

!NgLogPolicy methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:44'!
logger
	"Answer the value of logger"

	^ logger! !

!NgLogPolicy methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:44'!
logger: anObject
	"Set the value of logger"

	logger := anObject! !

!NgLogPolicy methodsFor: 'accessing' stamp: 'mu 5/3/2012 01:09'!
settings
	^self logger settings! !

!NgLogPolicy methodsFor: 'testing' stamp: 'mu 5/2/2012 23:23'!
shouldLogAccess
	^self logLevel >= 5! !

!NgLogPolicy methodsFor: 'testing' stamp: 'mu 5/2/2012 23:26'!
shouldLogAdmin
	^self logLevel >= 2! !

!NgLogPolicy methodsFor: 'testing' stamp: 'mu 5/2/2012 23:26'!
shouldLogDebug
	^self logLevel >= 3! !

!NgLogPolicy methodsFor: 'testing' stamp: 'mu 5/2/2012 23:18'!
shouldLogError
	^self logLevel >= 1! !

!NgLogPolicy methodsFor: 'testing' stamp: 'mu 5/2/2012 23:19'!
shouldLogFatal
	^self logLevel >= 1! !

!NgLogPolicy methodsFor: 'testing' stamp: 'mu 5/2/2012 23:24'!
shouldLogInfo
	^self logLevel >= 4! !

!NgLogPolicy methodsFor: 'testing' stamp: 'mu 5/2/2012 23:24'!
shouldLogProfile
	^self logLevel >= 3! !

!NgLogPolicy methodsFor: 'testing' stamp: 'mu 5/2/2012 23:24'!
shouldLogWarn
	^self logLevel >= 2! !

Object subclass: #NgPortableUtil
	instanceVariableNames: 'heartbeatProcess'
	classVariableNames: 'ActualClass'
	poolDictionaries: ''
	category: 'Nagare-Core'!

NgPortableUtil class
	instanceVariableNames: 'default'!

NgPortableUtil class
	instanceVariableNames: 'default'!

!NgPortableUtil class methodsFor: 'private' stamp: 'mu 5/2/2012 13:09'!
activate
	ActualClass := self.
	^ActualClass! !

!NgPortableUtil class methodsFor: 'accessing' stamp: 'mu 5/3/2012 15:32'!
actualClass

	^ActualClass ifNil: [self defaultActualClass]! !

!NgPortableUtil class methodsFor: 'instance creation' stamp: 'mu 5/3/2012 15:32'!
default
	default ifNil: [default := self actualClass activate new].
	^ default! !

!NgPortableUtil class methodsFor: 'accessing' stamp: 'mu 5/3/2012 15:31'!
defaultActualClass

	^(NgPortableUtil subclasses reject: [:each | '*Mock*' match: each name]) at: 1! !

!NgPortableUtil class methodsFor: 'class initialization' stamp: 'mu 5/2/2012 13:09'!
initDefault
	default := nil! !

!NgPortableUtil class methodsFor: 'class initialization' stamp: 'mu 5/2/2012 13:09'!
initialize
	"override"! !

!NgPortableUtil class methodsFor: 'class initialization' stamp: 'mu 5/4/2012 12:21'!
release
	"NgPortableUtil release"
	default ifNotNil: [default release].
	self initDefault.
	NgLogFactory initialize.! !

!NgPortableUtil methodsFor: 'converting' stamp: 'mu 5/3/2012 15:47'!
asRecord: anObject
	anObject class = Association ifTrue: [^ self dictionaryFromAssociations: (Array with: anObject)].
	(anObject class = Array and: [anObject notEmpty and: [(anObject at: 1) class = Association]])
		ifTrue: [^ self dictionaryFromAssociations: anObject].
	^anObject! !

!NgPortableUtil methodsFor: 'converting' stamp: 'mu 5/2/2012 14:58'!
dictionaryFromAssociations: assocs
	| dict |
	dict := Dictionary new: assocs size.
	dict addAll: assocs.
	^ dict! !

!NgPortableUtil methodsFor: 'converting' stamp: 'mu 5/3/2012 16:26'!
errorRecordFrom: anException
	| dic |
	(self isException: anException) ifFalse: [^anException].
	dic := Dictionary new.
	dic at: #receiver put: (self limitedStringFrom: anException receiver).	
	dic at: #description put: (self limitedStringFrom: anException description).
	dic at: #stack put:  (self shortStackStringFrom: anException).	
	^dic! !

!NgPortableUtil methodsFor: 'private' stamp: 'mu 5/2/2012 13:54'!
hearbeatTo: host port: port
	"override"
	"| udpSock |
	udpSock := Socket newUDP.
	udpSock sendData: '' toHost: host port: port."! !

!NgPortableUtil methodsFor: 'accessing' stamp: 'mu 5/2/2012 13:14'!
heartbeatProcess
	heartbeatProcess ifNil: [self prepareHeartbeatProcess].
	^ heartbeatProcess! !

!NgPortableUtil methodsFor: 'accessing' stamp: 'mu 5/2/2012 13:13'!
heartbeatProcess: anObject
	"Set the value of heartbeatProcess"

	heartbeatProcess := anObject! !

!NgPortableUtil methodsFor: 'initialize-release' stamp: 'mu 5/2/2012 14:06'!
initialize
	self listenSystemShutdownEvent.
	self prepareHeartbeatProcess! !

!NgPortableUtil methodsFor: 'private' stamp: 'mu 5/2/2012 17:19'!
isException: anException
	^ anException isKindOf: Exception! !

!NgPortableUtil methodsFor: 'converting' stamp: 'mu 5/3/2012 16:16'!
limitedStringFrom: anObject
	| str limitedStringSize |
	str := anObject isString ifTrue: [anObject] ifFalse: [anObject printString].
	limitedStringSize := self settings limitedStringSize.
	(str isEmpty or: [str size <= limitedStringSize]) ifTrue: [^str].
	^str copyFrom: 1 to: limitedStringSize! !

!NgPortableUtil methodsFor: 'shutdown' stamp: 'mu 5/2/2012 14:00'!
listenSystemShutdownEvent
	"override"
	"SmalltalkImage current addToShutDownList: self class"! !

!NgPortableUtil methodsFor: 'private' stamp: 'mu 5/4/2012 20:37'!
prepareHeartbeatProcess
	| port host process |
	host := self settings host.
	port := self settings port.
	process := [
		[self hearbeatTo: host port: port.
		(Delay forSeconds: self settings heartbeatInterval) wait] repeat.
	] newProcess.
	process priority: Processor userBackgroundPriority.
	process resume.
	
	self heartbeatProcess: process! !

!NgPortableUtil methodsFor: 'initialize-release' stamp: 'mu 5/2/2012 14:47'!
release
	self releaseHeartbeatProcess! !

!NgPortableUtil methodsFor: 'private' stamp: 'mu 5/2/2012 13:55'!
releaseHeartbeatProcess
	self heartbeatProcess ifNil: [^self].
	self heartbeatProcess terminate.
	self heartbeatProcess: nil! !

!NgPortableUtil methodsFor: 'sending' stamp: 'mu 5/2/2012 14:46'!
sendBytes: bytes
	"override"! !

!NgPortableUtil methodsFor: 'sending' stamp: 'mu 5/3/2012 17:27'!
sendLog: record tagged: tag on: logger
	| bytes |
	bytes := logger bytesToSendFrom: record tagged: tag.
	^self sendBytes: bytes! !

!NgPortableUtil methodsFor: 'accessing' stamp: 'mu 5/2/2012 13:49'!
settings
	^ NgSettings default! !

!NgPortableUtil methodsFor: 'converting' stamp: 'mu 5/2/2012 17:04'!
shortStackStringFrom: anException

	^self subclassResponsibility ! !

!NgPortableUtil methodsFor: 'accessing' stamp: 'mu 5/2/2012 14:29'!
unixTimeSeconds
	"override"
	^ 0! !

Object subclass: #NgSettings
	instanceVariableNames: 'settingsDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nagare-Core'!

NgSettings class
	instanceVariableNames: 'default'!

NgSettings class
	instanceVariableNames: 'default'!

!NgSettings class methodsFor: 'instance creation' stamp: 'mu 5/2/2012 13:40'!
default
	default ifNil: [default := self new].
	^default! !

!NgSettings class methodsFor: 'class initialization' stamp: 'mu 5/2/2012 13:39'!
initialize
	default := nil! !

!NgSettings methodsFor: 'actions-dictionary' stamp: 'mu 5/2/2012 13:38'!
at: key
	^self settingsDict at: key! !

!NgSettings methodsFor: 'actions-dictionary' stamp: 'mu 5/2/2012 13:38'!
at: key ifAbsent: aBlock
	^self settingsDict at: key ifAbsent: aBlock! !

!NgSettings methodsFor: 'actions-dictionary' stamp: 'mu 5/2/2012 13:38'!
at: key ifAbsentPut: aBlock
	^self settingsDict at: key ifAbsentPut: aBlock! !

!NgSettings methodsFor: 'actions-dictionary' stamp: 'mu 5/2/2012 13:38'!
at: key put: value
	^self settingsDict at: key put: value! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:29'!
defaultTagPrefix
	^self at: #defaultTagPrefix ifAbsentPut: ['st']! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/2/2012 15:29'!
defaultTagPrefix: aString
	^self at: #defaultTagPrefix put: aString! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:25'!
fatalClasses
	^self at: #fatalClasses ifAbsentPut: [Set new]! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:32'!
fatalClasses: aSet
	^self at: #fatalClasses put: aSet! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/4/2012 20:36'!
heartbeatInterval
	^self at: #heartbeatInterval ifAbsentPut: [1]! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/4/2012 20:36'!
heartbeatInterval: anInteger
	^self at: #heartbeatInterval put: anInteger! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/2/2012 16:36'!
host
	^self at: #host ifAbsentPut: ['localhost']! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/4/2012 12:20'!
host: hostAddressString
	NgLog release.
	^self at: #host put: hostAddressString! !

!NgSettings methodsFor: 'actions-dictionary' stamp: 'mu 5/2/2012 13:38'!
includesKey: key
	^self settingsDict includesKey: key! !

!NgSettings methodsFor: 'class initialization' stamp: 'mu 5/2/2012 13:38'!
initialize
	settingsDict := nil! !

!NgSettings methodsFor: 'actions-dictionary' stamp: 'mu 5/2/2012 13:38'!
keys
	^self settingsDict keys! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:02'!
limitedStringSize
	^self at: #limitedStringSize ifAbsentPut: [40]! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:03'!
limitedStringSize: anInteger
	^self at: #limitedStringSize put: anInteger! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:53'!
logLevel
	^self at: #logLevel ifAbsentPut: [5]! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:53'!
logLevel: anInteger
	^self at: #logLevel put: anInteger! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/2/2012 13:45'!
port
	^self at: #port ifAbsentPut: [24224]! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/4/2012 12:20'!
port: anInteger
	NgLog release.
	^self at: #port put: anInteger! !

!NgSettings methodsFor: 'accessing-private' stamp: 'mu 5/2/2012 13:38'!
settingsDict
	^ settingsDict ifNil: [settingsDict := IdentityDictionary new]! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/3/2012 16:40'!
useStomp
	^self at: #useStomp ifAbsentPut: [false]! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/3/2012 16:41'!
useStomp: aBoolean
	^self at: #useStomp put: aBoolean == true! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:25'!
warningClasses
	^self at: #warningClasses ifAbsentPut: [Set new]! !

!NgSettings methodsFor: 'accessing' stamp: 'mu 5/2/2012 17:33'!
warningClasses: aSet
	^self at: #warningClasses put: aSet! !

!Object methodsFor: '*Nagare-Core-accessing' stamp: 'mu 5/3/2012 00:04'!
>@ tagPrefix
	"Access to application prefixed logger"
	^ NgLogFactory @ tagPrefix ! !

!Object methodsFor: '*Nagare-Core-accessing' stamp: 'mu 5/3/2012 00:04'!
ng
	"Access to system default logger"
	^NgLog default! !

!Dictionary methodsFor: '*Nagare-Core-converting' stamp: 'mu 5/5/2012 21:18'!
, otherAssoc
	self at: otherAssoc key put: otherAssoc value.
	^self! !

!Association methodsFor: '*nagare-Core-converting' stamp: 'mu 5/5/2012 21:18'!
, otherAssoc
	| dict |
	dict := Dictionary new.
	dict at: self key put: self value.
	dict at: otherAssoc key put: otherAssoc value.
	^dict! !

Error subclass: #NgNetworkError
	instanceVariableNames: 'originalError'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nagare-Core'!

!NgNetworkError class methodsFor: 'instance creation' stamp: 'mu 5/2/2012 23:59'!
originalError: origError
	^self new originalError: origError; yourself! !

!NgNetworkError methodsFor: 'accessing' stamp: 'mu 5/3/2012 22:03'!
originalError
	"Answer the value of originalError"

	^ originalError! !

!NgNetworkError methodsFor: 'accessing' stamp: 'mu 5/3/2012 22:03'!
originalError: anObject
	"Set the value of originalError"

	originalError := anObject! !
NgLog initialize!
NgLogFactory initialize!
NgPortableUtil initialize!
NgSettings initialize!
